#ifndef EVENTQUEUE_H_
#define EVENTQUEUE_H_

#include <queue>

#include <GL/glfw.h>

#include "event.h"

class EventQueue
{
   public:
      EventQueue();
      virtual ~EventQueue();

      virtual NIGHT_Event* event();
      virtual bool hasEvent() {return !myQueue.empty();}
      virtual void processEvents();

   protected:
      void checkKeyboardEvents();
      void checkMouseEvents();
      void checkJoystickEvents();
      void checkSystemEvents();

      std::queue<NIGHT_Event*> myQueue;

      int myKeys[GLFW_KEY_LAST+1];
      int myLastKeys[GLFW_KEY_LAST+1];

      int myMouseX, myLastMouseX;
      int myMouseY, myLastMouseY;
      int myMouseButtons[GLFW_MOUSE_BUTTON_LAST+1];
      int myLastMouseButtons[GLFW_MOUSE_BUTTON_LAST+1];
      int myMouseWheel;
      int myLastMouseWheel;
};

#endif

