#ifndef UI_Cursor_h
#define UI_Cursor_h

#include <string>
#include <map>

#include <GL/glfw.h>

#include "screenvert.h"

//forward defs
class Cursor;

//typedefs
typedef std::map<std::string, Cursor*> CursorMap;
typedef CursorMap::iterator CursorMapIter;
typedef std::pair<std::string, Cursor*> CursorMapPair;

class Cursor
{
   public:
      Cursor(std::string filename);
      virtual ~Cursor();

      virtual void draw();

   protected:
      GLuint myTextureID;
      screenVert mySize;
      screenVert myOffset;
};


#endif
