#ifndef NIGHT_BITMAP_FONT
#define NIGHT_BITMAP_FONT

#include "font.h"

typedef struct char_data_type
{
	signed char width, height;
	signed char xorig, yorig;
	signed char advance;
	short		data_offset;
};

typedef struct font_data_type
{
	int				xmin, ymin;
	int				xmax, ymax;

	char_data_type	chars[256];
	unsigned char*	bitmap_data;
};

class bitmapFont : public NIGHT_Font
{
	public:
		bitmapFont(std::string fontName);
		virtual ~bitmapFont();

     //so many ways to print
     virtual void print(char* str,...) const;
     virtual void print(int x, int y, char* str, ...) const;
     virtual void print(float x, float y, char* str,...) const;
     virtual void print(float x, float y, float z, char* str, ...) const;

     //some size information
     virtual int string_width(char* str, ...) const;
     virtual int string_height(char* str, ...) const;

	private:
		font_data_type font_data;
};

#endif

