#include "font_repository.h"

#include <iostream>

#include "bitmap_font.h"

FontRepository::FontRepository()
{
    bitmapFont* temp_font;

	//Helvetica 10
	temp_font=new bitmapFont("HELVETICA10");
	addFont(temp_font);
	//Helvetica 12
	temp_font=new bitmapFont("HELVETICA12");
	addFont(temp_font);
	//Helvetica Bold 8
	temp_font=new bitmapFont("HELVETICA_BOLD8");
	addFont(temp_font);
	//Helvetica Bold 10
	temp_font=new bitmapFont("HELVETICA_BOLD10");
	addFont(temp_font);
	//Helvetica Bold 12
	temp_font=new bitmapFont("HELVETICA_BOLD12");
	addFont(temp_font);
	//Helvetica Bold 14
	temp_font=new bitmapFont("HELVETICA_BOLD14");
	addFont(temp_font);
	//Screen 12
	temp_font=new bitmapFont("SCREEN12");
	addFont(temp_font);
	//Screen 14
	temp_font=new bitmapFont("SCREEN14");
	addFont(temp_font);
	//Screen 15
	temp_font=new bitmapFont("SCREEN15");
	addFont(temp_font);


}

FontRepository::~FontRepository()
{
    //fontMapIter iter;
    fontMapIter iter;
    for(iter=myFonts.begin(); iter!=myFonts.end(); ++iter)
    {
        if(iter->second!=NULL)
        {
            delete iter->second;
        }
    }
}

NIGHT_Font* FontRepository::selectFont(std::string fontName)
{
    fontMapIter iter;
    iter=myFonts.find(fontName);
    if(iter==myFonts.end())
    {
        //font not located
        std::cout << "Font: " << fontName <<" not located" << std::endl;
        return NULL;  //may want to throw exception here
    }

    return iter->second;
}

bool FontRepository::addFont(NIGHT_Font* new_font)
{
    if(myFonts.find(new_font->name())!=myFonts.end())
    {
        //font is already loaded
        std::cout << "Font: " << new_font->name() <<" is already loaded" << std::endl;
        return false;
    }
    myFonts.insert(std::make_pair(new_font->name(), new_font));
    return true;
}

