#include "UI_area.h"

UI_area::UI_area()
{
}

UI_area::~UI_area()
{
	std::list<UI_element*>::iterator element_iter;
	unsigned int counter;

	for(element_iter=elements.begin(); element_iter!=elements.end(); element_iter++)
	{
		delete (*element_iter);
		element_iter=NULL;
	}

	for(counter=0; counter<spaces.size(); counter++)
	{
		delete spaces[counter];
		spaces[counter]=NULL;
	}
}

//rewrite this for a deep copy
UI_area::UI_area(const UI_area &copy_area)
{
	spaces=copy_area.spaces;
}

void UI_area::process_event(NIGHT_Event event)
{

	std::list<UI_element*>::iterator item_iter;

	for(item_iter=elements.begin();item_iter!= elements.end(); item_iter++)
	{
		(*item_iter)->process_event(event);
	}
	north.process_event(event);
	south.process_event(event);
	east.process_event(event);
	west.process_event(event);

	//process the current space
	if(current_space!=NULL)
	{
		current_space->process_event(event);
	}

	if(check_flag(MOUSE_OVER)==true)
	{
		switch (event.type)
		{
			case SDL_MOUSEMOTION:
			{
				NIGHT::set_cursor(default_cursor);
				set_flag(ACTIVE,true);
				break;
			}
			default:
			{
			}
		}
	}
	else
	{
		set_flag(ACTIVE,false);
	}

	set_flag(MOUSE_OVER, false);
}

/************************************************************
Area Draw

Input: Draw flags
Outputs: None
Actions: Draws all the elements of the screen using the draw
flags that are passed in.
************************************************************/
void UI_area::draw()
{
	std::list<UI_element*>::iterator item_iter;

	glPushName((GLuint)(this));
	glPushMatrix();
	glTranslatef(pos.x,pos.y, 0.1);
	glColor4f(col.r, col.g, col.b, col.a);
	draw_box(GL_POLYGON);


	for(item_iter=elements.begin();item_iter!= elements.end(); item_iter++)
	{
		(*item_iter)->draw();
	}

	//draw the current space
	if(current_space!=NULL)
	{
		current_space->draw();
	}

	north.draw();
	south.draw();
	east.draw();
	west.draw();

	glPopMatrix();
	glPopName();
}

void UI_area::arrange()
{

}


UI_area* UI_area_creator::create(TiXmlNode* node)
{
	temp=new UI_area();
	xml_fill(node, temp);
	return temp;
}

void UI_area_creator::xml_fill(TiXmlNode* node, UI_area* temp_area)
{
	TiXmlNode* current_node;
	TiXmlElement* element;
	const char* name;

	UI_element_creator::xml_fill(node, temp_area);

	current_node=node;
	element=current_node->FirstChildElement();

	while(element!=NULL)
	{
		name=element->Value();
		if (name== "Block")
		{
			UI_block* new_block;
			new_block=(UI_block*)UI_factory::create_element("BLOCK", element);
			temp_area->add(new_block);
		}
		else if (name=="Space")
		{
			//UI_space* new_space;
			//new_space=UI_factory::create_element("SPACE", element);
			//temp_area->add_space(new_space);
			//break;
		}
		element=current_node->NextSiblingElement();
	}
}

