#ifndef UI_BLOCK
#define UI_BLOCK

#include "prerequisites.h"
#include "UI_element.h"

//block flags
cosnt int VERTICLE=11;
const int HORZONTAL=12;
const int SQUARE=13;

/**********************************************************
The Block Class.
A block is a group of UI_buttons.  pop-up and pull-down 
menus are types of blocks.

**********************************************************/
class UI_block : public UI_composite_element
{
	public:
		UI_block() {}
		UI_block(string menu_string) {parse_menu_string(menu_string);}
		~UI_block() {}
		void draw();
		void process_event(SDL_Event event);
		void arrange();

		void get_value() {return value;}

	protected:
		int value;
		void parse_menu_string(char* input_string);
};

class UI_block_creator: public UI_element_creator
{
	public:
		UI_block_creator() {UI_factory::register_creator("BLOCK", this);}
		~UI_block_creator() {}
	
		UI_block* create(); {} //blocks must contain something
		UI_block* create(string menu_string);
		UI_block* create(TiXmlNode* node);

	protected:
		void xml_fill(TiXmlNode* node, UI_block* temp_block);
		UI_block* temp;
} block_instance;

#endif


