#include "UI_button.h"

UI_button::UI_button(Gui* g):
UI_element(g)
{
}

UI_button::~UI_button()
{
}

void UI_button::switch_color()
{
	if(checkFlag(ACTIVE)==true)
	{
		setColor(0.5,0.5,0.5,0.5);
		if(checkFlag(SELECTED)==true)
		{
			setColor(0.78,0.78,0.78,1.0);
		}
	}
	else
	{
		setColor(0.3,0.3,0.3,0.5);
	}
	glColor4f(myColor.r, myColor.g, myColor.b, myColor.a);
}

void UI_button::draw()
{
   UIListIter list_iter;

	glPushName((GLuint)(this));
	glPushMatrix();
	glTranslatef(myPosition.x, myPosition.y, 0.1);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	UI_element::draw();

	/*for(list_iter=myElements.begin(); list_iter!=myElements.end(); list_iter++)
	{
		(*list_iter)->draw();
	}

*/
	glDisable(GL_BLEND);
	glPopMatrix();
	glPopName();
}

void UI_button::process_event(NIGHT_Event event)
{
	if(checkFlag(MOUSE_OVER)==true)
	{
		switch(event.type)
		{
			case MOUSEMOTION:
			{
				setFlag(ACTIVE,true);
				break;
			}

			case MOUSEBUTTONDOWN:
			{
				setFlag(SELECTED, true);
				break;
			}

			case MOUSEBUTTONUP:
			{
			if(checkFlag(SELECTED)==true)
				{
					if(myCommand!=NULL)
					{
//						myCommand->execute();
					}
					setFlag(SELECTED, false);
				}
				break;
			}
		} //end switch
	} //end if mouse over
	else
	{
		//it's inactive
		setFlag(ACTIVE,false);
	}

	setFlag(MOUSE_OVER, false);
}


//look at redesigning this to be contained in it's own 0bject
void UI_button::arrange()
{
	int temp_x, temp_y, size_x, size_y;
	UIListIter list_iter;

	temp_x=0;
	temp_y=0;
	/*for(list_iter=myElements.begin(); list_iter!=myElements.end(); list_iter++)
	{
	   //horizantal arrangement
		(*list_iter)->setPosition(temp_x, 0);
		(*list_iter)->getSize(size_x, size_y);

      //increase the X dimension
		temp_x+=size_x;

		//find the largest Y dimmension
		if(size_y>temp_y)
		{
         temp_y=size_y;
		}

	}


   //adjust the composite elements size to the sum of child elements
	setSize(temp_x, temp_y);
	*/
}

/*UI_button* UI_button_creator::create(TiXmlNode* node)
{
	temp=new UI_button();
	xml_fill(node, temp);
	return temp;
}

void UI_button_creator::xml_fill(TiXmlNode* node, UI_button* temp_button)
{
	TiXmlNode* current_node;
	TiXmlElement* element;
	TiXmlElement* child_element;
	TiXmlText* text;
	string value;

	UI_element_creator::xml_fill(node, (UI_element*)temp_button);

	current_node=node;
	element=current_node->FirstChildElement();

	while(element!=NULL)
	{
		value=element->Value();
		if(value=="String")
		{
			UI_text_element* new_string;
			new_string=(UI_text_element*)UI_factory::create_text_element("TEXT_ELEMENT",element);
			temp_button->add(new_string);
			temp_button->set_flag(HAS_TEXT, true);
		}
		else if(value=="Tool_Tip")
		{
			child_element=current_node->FirstChildElement();
			text=child_element->ToText();
			temp_button->set_tool_tip(text->Value());
		}
		else if(value== "Icon")
		{
			temp_button->set_flag(HAS_ICON, true);
		}
		element=current_node->NextSiblingElement();
	}
}
*/

