#include "UI_composite_element.h"

UI_composite_element::UI_composite_element(Gui* gui, UI_arranger* arrange):
UI_element(gui),
myArranger(arrange)
{
}

UI_composite_element::~UI_composite_element()
{
   UIListIter list_iter;

	for(list_iter=myElements.begin(); list_iter!=myElements.end(); list_iter++)
	{
      delete (*list_iter);
	}
}

void UI_composite_element::remove(UI_element* old_element)
{
	UIListIter list_iter;

   for(list_iter=myElements.begin(); list_iter!=myElements.end(); ++list_iter)
   {
      if(*list_iter==old_element)
      {
         delete (*list_iter);
      }
   }
}

void UI_composite_element::arrange()
{
   myArranger->arrange();
}

UI_element* UI_composite_element::element(bool front=false)
{
   static UIListIter theIter=NULL;

   //never been called before
   if(theIter==NULL)
   {
      theIter=myElements.begin();
      return *theIter;
   }

   if(front==true)
   {
      theIter=myElements.begin();
      return *theIter;
   }

   theIter++;
   if(theIter==myElements.end())
   {
      return NULL;
   }

   return *theIter;
}

