#ifndef UI_COMPOSITE_ELEMENT_H
#define UI_COMPOSITE_ELEMENT_H

#include <list>

#include "UI_element.h"
#include "UI_arranger.h"

/************************************************************
base class for UI_composite objects.  Very abstract.
**********************************************************/
typedef std::list<UI_element*> UIList;
typedef std::list<UI_element*>::iterator UIListIter;

class UI_composite_element : public UI_element
{
	public:
		UI_composite_element(Gui* gui, UI_arranger* arrange);
		virtual ~UI_composite_element();

		virtual void process_event(NIGHT_Event event);
		virtual void draw();

      //composite functions
		virtual void add(UI_element* new_element) {myElements.push_back(new_element); arrange();}
		virtual void remove(UI_element* old_element);

      virtual void setArranger(UI_arranger* arranger) {myArranger=arranger;}
		virtual void arrange();

		//progressive iteration through all elements
		//if front==true, then start at the begining, otherwise, start at last
		//one returned.  Preloaded to false;
		virtual UI_element* element(bool front);

	protected:
      UI_arranger* myArranger;
		UIList myElements;
};

//does not need a creator
#endif



