#ifndef UI_EDGE
#define UI_EDGE


#include "UI_button.h"

//forward defs
class UI_area;
class UI_block;

//UI edge flags
const int SHOW_SPLIT_MENU=11;

/**********************************************************
Screen Edge Class:
An edge is what is between each area of the UI_screen. There
are edges around the border of a UI_screen as well.

**********************************************************/
class UI_edge : public UI_button
{
	public:
		UI_edge(UI_area* new_area);
		UI_edge(const UI_edge &edge);  //copy constructor for splitting areas
		~UI_edge();
		void draw();
		void process_event(NIGHT_Event event);

		bool is_horizontal() {return pos.y==size.y;}
		bool is_border();

		void set_other_area(UI_area* new_area) {other_area=new_area;}
		UI_area* get_other_area() {return other_area;}

	protected:
		UI_area *my_area, *other_area;  //the area that owns this edge, and the one it points to
		UI_block* split_menu;  //need this to initalize to the right values.
};

//the only commands that the edge buttons run
class edge_split_command: public UI_command
{
	public:
		edge_split_command();
		~edge_split_command();
		execute();
	protected:
};

class edge_merge_command: public UI_command
{
	public:
		edge_merge_command();
		~edge_merge_command();
		execute();
	protected:
};

class edge_move_command: public UI_command
{
	public:
		edge_move_command();
		~edge_move_command();
		execute();
	protected:
};

#endif

