#ifndef UI_Factory_h
#define UI_Factory_h

#include <map>
#include <list>
#include <string>


//forward defs
class UI_element;
class UI_element_creator;

typedef std::map<std::string , UI_element_creator*> factory_map_type;
typedef factory_map_type::iterator factory_iter_type;
typedef factory_map_type::value_type factory_pair;

/*
This is the factory that creates all of the elements for the GUI.  It is also responsible
for owning an destroying the elements.
*/

class UI_factory
{
	public:
		UI_factory();
		~UI_factory();

		static UI_element* create_element(std::string name);
		//static UI_element* create_element(std::string name, TiXmlNode* node);
		static void register_creator(std::string name, UI_element_creator* new_creator);

	private:
		static factory_map_type factory_map;
		static std::list<UI_element*> known_elements;

}

#endif



