#include "UI_text_element.h"

UI_text_element::UI_text_element(Gui* g):
myGui(g)
{
	setFlag(FIXED_LENGTH, false);
   myFontName="HELVETICA10";
	myFontColor.r=0.0;
	myFontColor.g=0.0;
	myfontColor.b=0.0;
	myFontColor.a=0.0;
	myText="Text";

	selectFont(myFontName);
	recalc_size();
}

void UI_text_element::setFont(std::string fontName)
{
   myFont=myGui->window()->fontRepository()->selectFont(myFontName);
}

void UI_text_element::setString(std::string new_string)
{
	myText=new_string;
	if(check_flag(FIXED_LENGTH)==false)
	{
		recalc_size();
	}
}

void UI_text_element::draw()
{
	glPushMatrix();
	glTranslate(myPosition.x, myPosition.y, 0.1);

	//draw the font
	glColor4f(myColor.r, myColor.g, myColor.b, myColor.a);
	myFont->print(0,0,myText);

	glPopMatrix();
}

void UI_text_element::recalc_size()
{
	mySize.x=myFont->string_width(myText);
	mySize.y=myFont->string_height(myText);
}