#ifndef UI_TEXT_ELEMENT_H
#define UI_TEXT_ELEMENT_H

#include <string>

#include "UI_element.h"
#include "screencolor.h"

//text flags
const int FIXED_LENGTH=21;

//forward defs
class NIGHT_font;

class UI_text_element: public UI_element
{
	public:
		UI_text_element(Gui* g);
		~UI_text_element();

		void draw();
		void process_event(NIGHT_Event event) {}  //just sits there like a bump on a log

		void setFont(std::string font_name);
		void setString(std::string new_string) {myText=new_string;}
		void setFontColor(screenColor c) {myColor=c;}
		void setFontColor(float nr, float ng, float nb, float na=0.0) {myColor.r=nr; myColor.g=ng; myColor.b=nb; myColor.a=na;}

	protected:
		NIGHT_Font* myFont;
		std::string myFontName;
		screenColor myColor;
		std::string myText;

		void recalc_size();
};

#endif
