#include "Gui.h"

#include <GL/glfw.h>

#include "screenvert.h"
#include "UI_element.h"

Gui::Gui(Window* win):
myWindow(win),
UI_composite_element(NULL, NULL)
{
}

Gui::~Gui()
{
}


void Gui::process_event(NIGHT_Event event)
{
   setMouseOver();
   UI_composite_element::process_event(event);
}

void Gui::setMouseOver()
{
	static const int BUFSIZE=512;
	static GLuint selection_buffer[BUFSIZE];
	int hits;
	GLuint num_names;
	GLuint min, max;
	GLuint *buffer_position;
	UI_element *hit_name;

	GLint viewport[4];
	screenVert mouse;

	//1. Get the window coordinates of the mouse
	glfwGetMousePos(&mouse.x, &mouse.y);

	//2. Enter selection mode
	glSelectBuffer(BUFSIZE,selection_buffer);
	glRenderMode(GL_SELECT);

	//3. Redefine the viewing volume so that only a small area of the window around the cursor is rendered
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	glGetIntegerv(GL_VIEWPORT,viewport);
	gluPickMatrix(mouse.x,viewport[3]-mouse.y, 2,2,viewport);

	//not sure why, but y axis is opposite from drawing setup-may be mouse coords are backwards?-this hack works
	gluOrtho2D(0,myWindow->width(),myWindow->height(),0);
	glMatrixMode(GL_MODELVIEW);
	glInitNames();

	//4. Render the scene, either using all primitives or only those relevant to the picking operation
	for(UIListIter iter=myElements.begin(); iter!=myElements.end(); ++iter)
	{
      (*iter)->draw();
	}

	//5. Exit selection mode and identify the objects which were rendered on that small part of the screen.
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glFlush();

	// returning to normal rendering mode
	hits = glRenderMode(GL_RENDER);

	// if there are hits process them
	if (hits != 0)
	{
		buffer_position=selection_buffer;
		for(int hit_counter=0; hit_counter<hits; hit_counter++)
		{
			num_names=*buffer_position;
			buffer_position++;
			min=*buffer_position;
			buffer_position++;
			max=*buffer_position;
			buffer_position++;
			for(unsigned int name_counter=0; name_counter<num_names; name_counter++)
			{
				//converting the "name" back into a pointer to be used
				hit_name=(UI_element*)*buffer_position;
				buffer_position++;
				hit_name->setFlag(MOUSE_OVER, true);
			}
		}
	}
}
