#include "gui_factory.h"

#include "UI_element.h"

#include <iostream>

//static instance
GuiFactoryMap guiFactory::myCreatorMap;

guiFactory::guiFactory()
{
}

guiFactory::~guiFactory()
{
}

bool guiFactory::add(std::string name, UI_element_creator* creator)
{
   GuiFactoryMapIter iter;
   iter=myCreatorMap.find(name);
   if(iter!=myCreatorMap.end())
   {
      //replace the original creator with the new one
      iter->second=creator;
      return true;
   }
   myCreatorMap.insert(GuiFactoryMapPair(name, creator));
   return true;
}

UI_element* guiFactory::create(std::string name)
{
   GuiFactoryMapIter iter;
   iter=myCreatorMap.find(name);
   if(iter==myCreatorMap.end())
   {
      std::cout << "Error: guiFactory::create() cannot find " << name << std::endl;
      throw("Error: guiFactory::create() cannot find" + name);
   }

   return iter->second->create();
}


