#ifndef GUI_FACTORY_H
#define GUI_FACTORY_H

#include <map>
#include <string>


//forward defs
class UI_element;
class UI_element_creator;


//typedefs
typedef std::map<std::string, UI_element_creator*> GuiFactoryMap;
typedef GuiFactoryMap::iterator GuiFactoryMapIter;
typedef std::pair<std::string, UI_element_creator*> GuiFactoryMapPair;


class guiFactory
{

   public:
      guiFactory();
      ~guiFactory();

      static bool add(std::string name, UI_element_creator* creator);
      static UI_element* create(std::string name);

   protected:
         static GuiFactoryMap myCreatorMap;
};

#endif

