#include "gui_repository.h"

void guiRepository::setMouseOver()
{
	static const int BUFSIZE=512;
	static GLuint selection_buffer[BUFSIZE];
	int hits;
	GLuint num_names;
	GLuint min, max;
	GLuint *buffer_position;
	UI_element *hit_name;

	GLint viewport[4];
	screen_vert mouse;

	//1. Get the window coordinates of the mouse
	get_mouse_coords(&mouse);

	//2. Enter selection mode
	glSelectBuffer(BUFSIZE,selection_buffer);
	glRenderMode(GL_SELECT);

	//3. Redefine the viewing volume so that only a small area of the window around the cursor is rendered
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	glGetIntegerv(GL_VIEWPORT,viewport);
	gluPickMatrix(mouse.x,viewport[3]-mouse.y, 2,2,viewport);

	//not sure why, but y axis is opposite from drawing setup-may be mouse coords are backwards?-this hack works
	gluOrtho2D(0,SCREEN_WIDTH,SCREEN_HEIGHT,0);
	glMatrixMode(GL_MODELVIEW);
	glInitNames();

	//4. Render the scene, either using all primitives or only those relevant to the picking operation
	screens[current_screen]->draw();

	//5. Exit selection mode and identify the objects which were rendered on that small part of the screen.
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glFlush();

	// returning to normal rendering mode
	hits = glRenderMode(GL_RENDER);

	// if there are hits process them
	if (hits != 0)
	{
		buffer_position=selection_buffer;
		for(int hit_counter=0; hit_counter<hits; hit_counter++)
		{
			num_names=*buffer_position; buffer_position++;
			min=*buffer_position; buffer_position++;
			max=*buffer_position; buffer_position++;
			for(int name_counter=0; name_counter<num_names; name_counter++)
			{
				//converting the "name" back into a pointer to be used
				hit_name=(UI_element*)*buffer_position; buffer_position++;
				hit_name->set_flag(MOUSE_OVER, true);
			}
		}
	}



}
